<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 15/10/2015
 * Time: 09:53
 */

namespace Factory;


class CalendarDetail
{

    public function createExceptionBase($calendar, $name, $status, $beginDate, $endDate, $timeBreak,$recurrenceUnit)
    {
        $entity = new \Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail();
        $entity->setCalendar($calendar);
        $entity->setName($name);
        $entity->setStatus($status);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setTimeBreak($timeBreak);
        $entity->setRecurrenceUnit($recurrenceUnit);
        $entity->setIsException('Y');
        return $entity;
    }

    public function updateExceptionBase(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $calendar, $name,
                                        $status, $beginDate, $endDate, $timeBreak,$recurrenceUnit)
    {
        $entity->setCalendar($calendar);
        $entity->setName($name);
        $entity->setStatus($status);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setTimeBreak($timeBreak);
        $entity->setRecurrenceUnit($recurrenceUnit);
        $entity->setIsException('Y');
        return $entity;
    }

    public function setWorkTime(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $type, $workTime)
    {
        $entity->setType($type);
        $entity->setDailyHours($workTime);
        return $entity;
    }

    public function clearFieldsRecurrence(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity)
    {
        $entity->setEvery(null);
        $entity->setMonthDay(null);
        $entity->setOrderDay(null);
        $entity->setMonth(null);
        $entity->setMonthDay(null);
        $entity->setWeekDay(null);
        return $entity;
    }

    public function setRecurrenceDaily(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $every)
    {
        $entity->setEvery($every);
        return $entity;
    }

    public function setRecurrenceWeekly(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $every)
    {
        $entity->setEvery($every);
        return $entity;
    }

    public function setRecurrenceMonthlyDay(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $every,
                                            $monthlyDay)
    {
        $entity->setEvery($every);
        $entity->setMonthDay($monthlyDay);
        $entity->setMonth($entity->getBeginDate()->format('d'));
        return $entity;
    }

    public function setRecurrenceMonthlyWeek(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $every,
                                             $weekDay, $orderDay)
    {
        $entity->setEvery($every);
        $entity->setWeekDay($weekDay);
        $entity->setOrderDay($orderDay);
        return $entity;
    }

    public function setRecurrenceYearlyDay(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $monthlyDay,
                                           $monthly)
    {
        $entity->setMonth($monthly);
        $entity->setMonthDay($monthlyDay);
        return $entity;
    }

    public function setRecurrenceYearlyWeek(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity, $orderDay,
                                            $weekDay, $monthly)
    {
        $entity->setMonth($monthly);
        $entity->setWeekDay($weekDay);
        $entity->setOrderDay($orderDay);
        return $entity;
    }
    public function createWeekWorkBase($calendar, $name, $beginDate, $endDate, $status = 'A')
    {
        $entity = new \Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail();
        $entity->setCalendar($calendar);
        $entity->setName($name);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setStatus($status);
        $entity->setIsException('N');
        return $entity;
    }
    public function updateWeekWorkBase(\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarDetail $entity,$calendar, $name, $beginDate, $endDate, $status = 'A')
    {
        $entity->setCalendar($calendar);
        $entity->setName($name);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setStatus($status);
        $entity->setIsException('N');
        return $entity;
    }
}